org.apache.tinkerpop.gremlin.process.traversal.step.map

## Class TreeStep<S>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,E>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.util.ReducingBarrierStep<S,Tree>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.map.TreeStep<S>

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<Tree>>, Step<S,Tree>, Barrier<Tree>, ByModulating, Generating<Tree,Tree>, MemoryComputing<Tree>, PathProcessor, TraversalParent

      public final class TreeStep<S>
      extends ReducingBarrierStep<S,Tree>
      implements TraversalParent, ByModulating, PathProcessor

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `TreeStep.TreeBiOperator`

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.PathProcessor

      `PathProcessor.ElementRequirement`

  - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.ReducingBarrierStep

      `reducingBiOperator, seedSupplier`

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TreeStep(Traversal.Admin traversal)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `TreeStep<S>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `Set<String>` | `getKeepLabels()`
    `List<Traversal.Admin<Object,Object>>` | `getLocalChildren()`
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `int` | `hashCode()`
    `void` | `modulateBy(Traversal.Admin<?,?> treeTraversal)`
    `Tree` | `projectTraverser(Traverser.Admin<S> traverser)`
    `void` | `reset()` Reset the state of the step such that it has no incoming starts.
    `void` | `setKeepLabels(Set<String> keepLabels)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.ReducingBarrierStep

      `addBarrier, done, getBiOperator, getMemoryComputeKey, getSeedSupplier, hasNextBarrier, nextBarrier, processAllStarts, processNextStart, setReducingBiOperator, setSeedSupplier`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getTraversal, hasNext, next, removeLabel, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getGlobalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.ByModulating

      `modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.PathProcessor

      `getMaxRequirement, processTraverserPathLabels`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Generating

      `generateFinalResult`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### TreeStep

          public TreeStep(Traversal.Admin traversal)

  - ### Method Detail

    - #### getLocalChildren

          public List<Traversal.Admin<Object,Object>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### modulateBy

          public void modulateBy(Traversal.Admin<?,?> treeTraversal)

      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S,Tree>`
      Returns:
        the set of requirements

    - #### projectTraverser

          public Tree projectTraverser(Traverser.Admin<S> traverser)

      Specified by:
        `projectTraverser` in class `ReducingBarrierStep<S,Tree>`

    - #### clone

          public TreeStep<S> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,Tree>`
      Overrides:
        `clone` in class `ReducingBarrierStep<S,Tree>`
      Returns:
        The cloned step

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<S,Tree>`
      Overrides:
        `setTraversal` in class `AbstractStep<S,Tree>`
      Parameters:
        `parentTraversal` - the new traversal for this step

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<S,Tree>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<S,Tree>`

    - #### reset

          public void reset()

      Description copied from interface: `Step`
      Reset the state of the step such that it has no incoming starts. Internal states are to be reset, but any sideEffect data structures are not to be recreated.
      Specified by:
        `reset` in interface `Step<S,Tree>`
      Overrides:
        `reset` in class `ReducingBarrierStep<S,Tree>`

    - #### setKeepLabels

          public void setKeepLabels(Set<String> keepLabels)

      Specified by:
        `setKeepLabels` in interface `PathProcessor`

    - #### getKeepLabels

          public Set<String> getKeepLabels()

      Specified by:
        `getKeepLabels` in interface `PathProcessor`

Copyright © 2013–2020 Apache Software Foundation. All rights reserved.